/*## (c) SECURITY EXPLORATIONS    2013 poland                                #*/
/*##     http://www.security-explorations.com                                #*/

/* Proxy Server                                                               */
/* proxy http/https traffic through servlet                                   */
/* usage: Proxy portnum servlet_url user pass [-s][-d]                        */
/*    portnum     - local port to listen on                                   */
/*    servlet_url - target servlet to proxy traffic through                   */
/*    user        - username                                                  */
/*    pass        - password                                                  */
/*    -s          - indicates if proxy should enforce ssl for all connections */
/*    -d          - indicates if direct connections should be used            */

/* THIS SOFTWARE IS PROTECTED BY DOMESTIC AND INTERNATIONAL COPYRIGHT LAWS    */
/* UNAUTHORISED COPYING OF THIS SOFTWARE IN EITHER SOURCE OR BINARY FORM IS   */
/* EXPRESSLY FORBIDDEN. ANY USE, INCLUDING THE REPRODUCTION, MODIFICATION,    */
/* DISTRIBUTION, TRANSMISSION, RE-PUBLICATION, STORAGE OR DISPLAY OF ANY      */
/* PART OF THE SOFTWARE, FOR COMMERCIAL OR ANY OTHER PURPOSES REQUIRES A      */
/* VALID LICENSE FROM THE COPYRIGHT HOLDER.                                   */

/* THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS    */
/* OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,*/
/* FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL    */
/* SECURITY EXPLORATIONS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, */
/* WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF  */
/* OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE     */
/* SOFTWARE.                                                                  */

import java.net.*;
import java.io.*;
import java.util.*;
import sun.misc.*;

public class Proxy {
  public static String URL;
  public static String AUTHORIZATION;

  static String options[]={
    "-s","s=true",
    "-d","d=true"
  };

  public static void usage() {
   System.out.println("usage: Proxy portnum servlet_url user pass [-s][-d]");
   System.exit(0);
  }

  public static void error(String s) {
   System.out.println("error: "+s);
   System.exit(1);
  }

  public static String get_option(String opt) {
   for(int i=0;i<options.length;i+=2) {
     if (options[i].equals(opt)) {
       return options[i+1];
     }
   }

   return null;
  }

  public static void run(int port) {
   try {
    ServerSocket srv=null;

    try {
     srv=new ServerSocket(port);
    } catch (IOException e) {
     error("cannot listen on "+port);
    }

    System.out.println("proxy port : "+port);
    System.out.println("servlet url: "+URL);

    while(true) {
     Socket sck=srv.accept();
     Client cl=new Client(sck);
     cl.start();
    }

   } catch(Throwable t) {
    t.printStackTrace();
   }
  }

  public static void prepare_authorization(String s) {
   BASE64Encoder encoder=new BASE64Encoder();
   AUTHORIZATION=encoder.encodeBuffer(s.getBytes()).trim();
  }

  public static void main(String[] args) {
   try {   
    if (args.length<4) usage();

    int port=-1;

    try {
     port=Integer.parseInt(args[0]);
    } catch (Exception e) {
     error("invalid port "+port);          
    }

    String url=args[1];

    try {
     new URL(url);
    } catch (Exception e) {
     error("invalid url "+url);          
    }

    String user=args[2];
    String pass=args[3];

    String s=user+":"+pass;

    prepare_authorization(s);

    int optnum=0;

    if (args.length>4) {
     for(int i=4;i<args.length;i++) {
      String opt=get_option(args[i]);
      if (opt==null) usage();

      if (optnum==0) {
       url+="?";
      } else {
       url+="&";
      }

      url+=opt;
      optnum++;     
     }
    }

    URL=url;

    run(port);
   } catch(Throwable t) {
    t.printStackTrace();
   }
  }
}
