/*## (c) SECURITY EXPLORATIONS    2013 poland                                #*/
/*##     http://www.security-explorations.com                                #*/

/* THIS SOFTWARE IS PROTECTED BY DOMESTIC AND INTERNATIONAL COPYRIGHT LAWS    */
/* UNAUTHORISED COPYING OF THIS SOFTWARE IN EITHER SOURCE OR BINARY FORM IS   */
/* EXPRESSLY FORBIDDEN. ANY USE, INCLUDING THE REPRODUCTION, MODIFICATION,    */
/* DISTRIBUTION, TRANSMISSION, RE-PUBLICATION, STORAGE OR DISPLAY OF ANY      */
/* PART OF THE SOFTWARE, FOR COMMERCIAL OR ANY OTHER PURPOSES REQUIRES A      */
/* VALID LICENSE FROM THE COPYRIGHT HOLDER.                                   */

/* THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS    */
/* OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,*/
/* FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL    */
/* SECURITY EXPLORATIONS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, */
/* WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF  */
/* OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE     */
/* SOFTWARE.                                                                  */

import java.lang.*;
import java.io.*;
import java.security.*;
import com.oracle.cie.domain.security.*;
import weblogic.security.subject.*;

public class DumpPass {
  public static void usage() {
    System.out.println("usage: DumpPass [enc|dec] input");
    System.exit(0);
  }

  public static void main(String[] args) {
    try {
      if (args.length!=2) usage();
      String mode=args[0];       
      String in=args[1];

      SubjectManager.ensureInitialized();

      DomainSecurityService dss=DomainSecurityService.getInstance(".");
      System.out.println("dss "+dss);

      int decenc=-1;
      
      if (mode.equals("dec")) decenc=1;
        else
      if (mode.equals("enc")) decenc=0;

      if (decenc==-1) usage();

      String out=null;

      try {
       out=dss.convUP(in,"SerializedSystemIni.dat",decenc);
      } catch(Throwable t) {}



      if (out==null) {
        try {
          out=dss.mima(in,decenc);
        } catch(Throwable t) {}
      }

      System.out.println("in:  "+in);
      System.out.println("out: "+out);
    } catch (Exception e) { 
      e.printStackTrace();   
    } 
  }
}
